package distantplanets;

import java.util.Stack;

import driver.Binary;

public class Planetscape {
	/* 
	 * structure is an attempt to mirror the structure of the disassembled code, thus
	 * the excessive functions and names just for names' sake
	 */
	
	Screen screen1;
	
	Random rand;
	
	int seed;
	
	int [] AnArray;
	int AnArrayCounter;
	int [] palette; // palette
	SomeStruct [] StructArray;
	int [] SinTab;
	
	int anotherSeed;
	int HorizonLine;
	int skyPal;
	int anotherSeed4;
	int anotherSeed5;
	int anotherSeed6;
	int anotherSeed7;
	int anotherSeed8;
	int anotherSeed9;
	
	int landscapeType;
	
	int MinY;
	int MinX;
	int MaxY;
	int MaxX;
	
	int ValCleared3;
	
	boolean Flag1;
	boolean SkyFlag;
	int skyRandomness;

	// hopefully I can do away with this as I understand the calculations better 
	Stack fpstack;
	
	public Planetscape(int n) {
		InitSinTab();
		screen1 = new Screen(800,640);
		MinY=0;
		MinX=0;
		MaxY=0x257;
		MaxX=0x31f;
		fpstack = new Stack();
		
		DoThatThang(n);		
	}
	/*
	public Planetscape() {
		
		// 24974
		//DoThatThang(3049);
		//DoThatThang(21938);
		//DoThatThang(3674);
		Planetscape(-1);
	}
	*/
	
	public Screen getScreen() {return screen1;}
	public int getSeed() {return seed;}
	
	void InitSinTab() {
		SinTab = new int [0x800];
		for (int c=0;c<0x400;c++) {
			double t =
				Math.sin(((double)c) * 3.067961575771282e-3)*3.2768e4;
			
			if (t>0) t+=0.5; // round away from 0
			else t-=0.5;
			
			SinTab[c]=(int)t;
			SinTab[c+0x400]=(int)(-t);
		}
	}
	
	void DoThatThang(int seed) {
		if (seed<0) seed=(new java.util.Random().nextInt())&0x7fff;
		this.seed=seed;
		System.out.println("image number "+seed);
		rand = new Random(seed);
		
		screen1.clear();
		
		RandomCrap1();
		
		int features=rand.rand()%3;
		int t=rand.rand()&1;
		
		DrawSky();
		
		if (features != 0) {
			Galaxy();
		}
		if (features != 2) {
			Planet1();
			Planet2();
		}
	}
	
	/**
	 * setup palette, decide what kind of scene to draw
	 *
	 */
	void RandomCrap1() {
		palette = new int [0x100];
		for (int i=0;i<palette.length;i++) palette[i]=0; // redundant in Java?
		initAnArray();
		
		// fun with fixed point arithmetic
		long tmp = 0x31Fl*25l*0x51eb851fl;
		tmp >>= 32;
		anotherSeed = (int)(tmp/32 + ((tmp >> 31) & 1));
		
		System.out.println("anotherSeed="+anotherSeed);
		
		long landnum = rand.rand() % 0x64;
		
		if (landnum < 0x14) landscapeType=0; // layered mountains
		else if (landnum < 0x28) landscapeType=1; // hilly
		else if (landnum < 0x3c) landscapeType=2; // flat
		else landscapeType=3; // ocean + mountains on horizon
		
		System.out.println("landscape type: "+landscapeType);
		
		tmp=((AnArray[AnArrayCounter&0x3fff]%0x19)+0x3c)*(long)(0x257-MinY)*0x51eb851fl;
		tmp >>= 32;
		HorizonLine = (int)(tmp / 32 + ((tmp >> 31) & 1)) + MinY;
		
		AnArrayCounter++;
		
		if (landscapeType==3) {
			tmp=((AnArray[AnArrayCounter&0x3fff]%0x1e)+0x32)*(long)(0x257-MinY)*0x51eb851fl;
			tmp >>= 32;
			HorizonLine = (int)(tmp / 32 + ((tmp >> 31) & 1)) + MinY;
			
			AnArrayCounter++;
		}
		
		System.out.println("horizon at="+HorizonLine);
		
		Flag1 = (rand.rand()&1)==1;
		SkyFlag = (rand.rand()&1)==1;
		skyRandomness = (rand.rand()&3)+1;
		
		System.out.println("Flag1="+Flag1);
		System.out.println("Sky: "+SkyFlag);
		System.out.println("skyRandomness="+skyRandomness);
		
		int temprand = rand.rand();
		temprand = (temprand&(~0xff)) | ((-(temprand&3))&0xff); 
		int borrow=0;
		if ((temprand&0xff)!=0) borrow=1;
		
		ValCleared3=0;
		
		skyPal=-(temprand-(temprand+borrow));
		System.out.println("skyPal?="+skyPal);
		
		
		if (SkyFlag && skyPal != 0) {
			ValCleared3=(rand.rand()&7)+0x14;
		} else {
			long r = rand.rand();
			r = r%0x18+4;
			
			ValCleared3=(int)r;
		}
		
		System.out.println("ValCleared3=0x"+Binary.intToHex(ValCleared3));
		
		{
			int i;
			if ((rand.rand()&1) == 1 && ValCleared3 > 0x10) {
				i=1;
			} else {
				i=0;
			}
			
			anotherSeed4=i+1;
		}
		
		System.out.println("anotherSeed4="+anotherSeed4);

		anotherSeed5=0x31f;
		anotherSeed6=(rand.rand()%(0x800/((skyPal+1)*6)))-0x800/((skyPal+1)*12);
		
		System.out.println("anotherSeed6="+anotherSeed6+" "+Binary.intToHex(anotherSeed6));
		
		anotherSeed7=(int)(((HorizonLine+MinY)-(((long)HorizonLine+MinY)>>32))>>1);
		System.out.println("anotherSeed7=0x"+Binary.intToHex(anotherSeed7));

		// unsigned multiply
		anotherSeed8=(int)(anotherSeed5-(((rand.rand()%(0x31f-MinX))*0x0CCCCCCCDl)>>35));
		
		System.out.println("anotherSeed8="+Binary.intToHex(anotherSeed8));
		
		{
			int ecx = (MinY+HorizonLine)*anotherSeed6;
			int edx = ((int)((ecx*(long)0xA03C1689)>>32)+ecx)>>8; // signed multiply
			edx+=(edx>>31)&1;
			anotherSeed9=anotherSeed7+edx*2;
			
			System.out.println("anotherSeed9="+Binary.intToHex(anotherSeed9));
		
			if (skyPal != 0) {
				anotherSeed7 = anotherSeed9 - edx;
				anotherSeed5 = anotherSeed8;
				System.out.println("anotherSeed7="+Binary.intToHex(anotherSeed7));
				System.out.println("anotherSeed5="+Binary.intToHex(anotherSeed5));
			}
		}
		
		{
			int j=0;
			StructArray = new SomeStruct [7];
			for (int i=0;i<=6;i++) {
				if (i >= 5) {
					StructArray[i]=new SomeStruct(j,j+0x1f,HorizonLine,0x257);
				} else {
					StructArray[i]=new SomeStruct(j,j+0x1f,MinY,HorizonLine);
				}
				j+=0x20;
			}			
		}
		
		StructArray[5].x=StructArray[5].w-1;
		StructArray[6].x=StructArray[6].w-1;
		
		if (SkyFlag) {
			generateColors(0,0x0f,0x1c,0x3f,0x20,0x3f);
		} else {
			generateColors(0,0x05,0x1e,0x3a,0x20,0x3f);
		}
		
		generateColors(0x23,0x39,0x3a,0x3f,0x10,0x1f);
		
		generateColors(3,0x1a,0x1c,0x3f,0x80,0x9f);
		
		if (!Flag1) {
			generateColors(1,0x12,0x1a,0x3f,0x40,0x5f);
		} else {
			StructArray[2].x=StructArray[2].w-1;
		}
		
		{
			int color1=0;
			for (int i=0;i<3;i++) {
				color1<<=8;
				int j=AnArray[AnArrayCounter&0x3fff]&0x80000003;
				if (i<0) {
					j--;
					j|=0xFFFFFFFC;
					j++;
				}
				color1|=j+4;
				
				AnArrayCounter++;
			}
			
			int color2=0;
			for (int i=0;i<3;i++) {
				color2<<=8;
				color2|=AnArray[AnArrayCounter&0x3fff]%0x18+0x28;
				AnArrayCounter++;
			}
			
			generateGradient(0x60,0x7f,color1,color2);
		}
	}
	
	void initAnArray() {
		AnArray = new int [0x4000];
		for (int i=0;i<AnArray.length;i++) AnArray[i]=rand.rand();
		AnArrayCounter=0;
	}
	
	void generateColors(int intensity1_start, int intensity1_end, int intensity2_start, int intensity2_end, int startidx, int endidx) {
		int rand1,rand2;
		int [] startcolor1 = new int [3];
		int [] endcolor1 = new int [3];
		int [] startcolor2 = new int [3];
		int [] endcolor2 = new int [3];
		
		System.out.println("generateColors(0x"+Binary.intToHex(intensity1_start)+",0x"+Binary.intToHex(intensity1_end)+
				",0x"+Binary.intToHex(intensity2_start)+",0x"+Binary.intToHex(intensity2_end)+",0x"+Binary.intToHex(startidx)+",0x"+
				Binary.intToHex(endidx)+")");
		
		rand1=rand.rand()%3; // choose channel to change in start colors 
		rand2=rand.rand()%3; // choose channel to change in end colors
		
		// loop through channels
		for (int i=0;i<3;i++) {
			startcolor1[i]=intensity1_start;
			endcolor1[i]=intensity1_end;
			startcolor2[i]=intensity2_start;
			endcolor2[i]=intensity2_end;
			if (i==rand1) {
				startcolor1[i]=(intensity1_start+intensity1_end)/2;
				startcolor2[i]=(intensity2_start+intensity2_end)/2;
			} else if (i==rand2) {
				endcolor1[i]=(intensity1_start+intensity1_end)/2;
				endcolor2[i]=(intensity2_start+intensity2_end)/2;
			}
		}
		
		{
			int [] color5 = new int [3];
			int [] color6 = new int [3];
			
			color5[0] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor1[0]-startcolor1[0]+1)+startcolor1[0]);				
			AnArrayCounter++;
			color5[1] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor1[1]-startcolor1[1]+1)+startcolor1[1]);
			AnArrayCounter++;
			color5[2] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor1[2]-startcolor1[2]+1)+startcolor1[2]);			
			AnArrayCounter++;
			
			color6[0] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor2[0]-startcolor2[0]+1)+startcolor2[0]);			
			AnArrayCounter++;
			color6[1] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor2[1]-startcolor2[1]+1)+startcolor2[1]);
			AnArrayCounter++;
			color6[2] = (int)((long)AnArray[AnArrayCounter&0x3fff]%(endcolor2[2]-startcolor2[2]+1)+startcolor2[2]);
			AnArrayCounter++;
			
			generateGradient(startidx,endidx,(color5[0]<<16)|(color5[1]<<8)|(color5[2]), (color6[0]<<16)|(color6[1]<<8)|(color6[2]));
		}
	}
	
	void generateGradient(int startidx, int endidx, int startcolor, int endcolor) {
		System.out.println("generateGradient(0x"+Binary.intToHex(startidx)+",0x"+Binary.intToHex(endidx)+",0x"+
				Binary.intToHex(startcolor)+",0x"+Binary.intToHex(endcolor)+")");
		
		int len=endidx-startidx;
		int col0start=startcolor&0xff;
		int col1start=(startcolor>>8)&0xff;
		int col2start=(startcolor>>16)&0xff;
		int col0end=endcolor&0xff;
		int col1end=(endcolor>>8)&0xff;
		int col2end=(endcolor>>16)&0xff;
		int col0span=col0end-col0start;
		int col1span=col1end-col1start;
		int col2span=col2end-col2start;
		
		int incval0=len*4;
		int incval1=incval0;
		int incval2=incval1;
		
		if (len < 0) {System.out.println("len < 0");}
		if (col0span < 0 || col1span < 0 || col2span < 0) {System.out.println("colspan < 0");}
		if (len==0) return;
				
		for (int i=0;i<=len;i++) {
			palette[i+startidx]=
			(((incval2/(len*2)+col2start*4)&0xff)<<16)|
			(((incval1/(len*2)+col1start*4)&0xff)<<8)|
			(((incval0/(len*2)+col0start*4)&0xff)<<0);
			incval0+=col0span*8;
			incval1+=col1span*8;
			incval2+=col2span*8;
			//System.out.println(i+": "+Binary.intToHex(palette[i+startidx]));
		}
	}
	
	void DrawSky() {
		int yGradient,xGradient,brightness,startBrightness;
		if (SkyFlag) { 
			int gradientAngle=(rand.rand()&3)+
				((int)((skyPal<<5)+((((long)(skyPal<<5))>>32)&3))>>2);
			int y=HorizonLine;
			int x;
			startBrightness=0x3e-gradientAngle;
			//System.out.println("brightnessRange=0x"+Binary.intToHex(brightnessRange));
			//System.out.println("startBrightness=0x"+Binary.intToHex(startBrightness));
			startBrightness-=skyRandomness;
			xGradient=(int)(((long)(gradientAngle<<8))/(MaxX-MinX+1));
			yGradient=(int)(((long)((0x20-startBrightness)<<8))/(HorizonLine-MinY+1));
			startBrightness<<=8;
			brightness=startBrightness;
			
			
			//System.out.println("xGradient=0x"+Binary.intToHex(xGradient));
			//System.out.println("yGradient=0x"+Binary.intToHex(yGradient));
			
			while (y>=MinY) {
				x=MinX;
				while (x <= MaxX) {
					int colidx=(AnArray[AnArrayCounter&0x3fff]%(skyRandomness << 8)+brightness)>>8;
					AnArrayCounter++;
					screen1.setPixel(x,y,palette[colidx]);
					brightness+=xGradient;
					x++;
				}
				brightness=startBrightness+=yGradient;
				y--;
			}
			if ((rand.rand()&1)!=1) return;
		}
		
		DrawStars();
		//System.out.println("AnArrayCounter="+Binary.intToHex(AnArrayCounter));
	}
	
	/**
	 * stars?
	 *
	 */
	void DrawStars() {
		System.out.println("stars");
		for (int numstars=rand.rand()%0x32+0x4b;numstars>0;numstars--) {
			
			int x = rand.rand()%(MaxX-MinX)+MinX;
			int y = rand.rand()%(HorizonLine-MinY)+MinY;
			
			// if the sky is there we must interpolate
			int newval;
			if (SkyFlag) {
				int curval = screen1.getPixel(x,y);
				//System.out.println("("+x+","+y+")="+Binary.intToHex(screen1.getPixel(x,y)));
				newval= 
					((((rand.rand()&0xff)+(curval&0xff))/2)&0xff) |
					(((((rand.rand()&0xff)<<8)+(curval&0xff00))/2)&0xff00) |
					(((((rand.rand()&0xff)<<16)+(curval&0xff0000))/2)&0xff0000);
				
			} else {
				newval = ((rand.rand()&0xfff)<<12) | (rand.rand()&0xfff);
			}
			screen1.setPixel(x,y,newval);
			//System.out.println("star("+x+","+y+")="+Binary.intToHex(screen1.getPixel(x,y)));
		}
	}
	
	void Galaxy() {
		System.out.println("Galactic domination");
		
		int var_14,var_18,var_1C,var_20,var_24,var_28,var_2C,var_30,var_34,var_38,var_3C,var_40;
		double var_8,var_C,var_10;
		byte [] buffer=null;
				
		boolean Flag1=(rand.rand()&0xf)>7;
		System.out.println("GalaxyFlag1="+Flag1);
		
		int ebx = (int)(((long)rand.rand())%anotherSeed5);
		
		int edx = (int)((anotherSeed5*0x66666667l)>>32)>>3;
		edx+=(edx>>31)&1;
		ebx-=edx;
		
		var_20=ebx;
		//System.out.println("var_20="+Binary.intToHex(var_20)); // x coord?
				
		int ecx=HorizonLine*6;
				
		ecx=(int)((ecx*0x66666667l)>>33);
		ecx+=(ecx>>31)&1;
		edx=(int)(rand.rand()%((long)ecx));
		
		int ebp=edx;
		
		edx=(int)((HorizonLine*0x66666667l)>>34);
		edx+=(edx>>31)&1;
		ebp-=edx;
		
		//System.out.println("ebp="+Binary.intToHex(ebp));
		
		var_1C=ebp;
		
		do {
			var_30=rand.rand()&0xff;
			var_34=rand.rand()&0xff;
			var_38=rand.rand()&0xff;
			ecx=var_38*var_38;
			edx=var_34*var_34;
			ecx+=edx; // calculation of hypotenuse?			
			edx=var_30*var_30;
			ecx+=edx; // another dimension?
			
			//System.out.println("var_38=0x"+Binary.intToHex(var_38));
		} while (ecx>=0x124F8);
		
		if (SkyFlag) {
			var_30/=2;
			var_34/=2;
			var_38/=2;
		}
		
		var_18=0x15;
		
		// convert to doubles
		var_10=var_30;
		var_C=var_34;
		var_8=var_38;
		
		edx=(rand.rand()%0x1a)+0xe;
		
		edx*=3;
		ecx=edx*5;
		ecx*=5;
		ecx<<=3;
		
		edx=(int)((ecx*0x51eb851fl)>>37);
		edx+=(edx>>31)&1;
		var_14=edx;
				
		if (edx<var_18) return;

		edx=var_18*2;
		
		edx=(int)((edx*0x55555556l)>>32);
				
		ecx=var_14*var_14;
		edx+=(edx>>31)&1;
		ebp=edx;
		
		edx=(((int)((ecx*((long)0xDD67C8A7))>>32))+ecx)>>5;
		edx+=(edx>>31)&1;
		var_24=edx;
		//System.out.println("var_24=0x"+Binary.intToHex(var_24));
		var_28=var_14-ebp;
		//System.out.println("var_28=0x"+Binary.intToHex(var_28));
		var_2C=ebp;
		//System.out.println("var_2C=0x"+Binary.intToHex(var_2C));
		var_30=0;

		int sideLen=0; // aka radius
		ebx = var_24;
		
		var_38=0; // these will be initialized on the first pass through the 
		var_3C=0; // below loop, but this shuts up Java
		var_40=0;
		
		for (var_30=0;var_30<var_24;var_30++) {
			
			// in the code these are skipped the first time because the regs were used in the above
			// initialization of the vars
			ebp = var_2C;
			int esi = var_28;
			int edi = var_34;
			
			edx=var_30&7;
			if (edx==0) {
				edi=var_38=(int)var_10; // _ftol, throw away high dword
				ebx=var_3C=(int)var_C;
				ecx=var_40=(int)var_8;
				//Flag1=true;
				if (Flag1) {
					//System.out.println("edi=0x"+Binary.intToHex(edi)+
					//		" ebx="+Binary.intToHex(ebx)+
					//		" ecx="+Binary.intToHex(ecx));
					int eax=edi*11+8;
					eax+=(((long)eax)>>32)&0xF;
					var_38=eax>>4;
					//System.out.println("var_38=0x"+Binary.intToHex(var_38));
					
					eax=ebx*11+8;
					eax+=(((long)eax)>>32)&0xF;
					var_3C=eax>>4;
					//System.out.println("var_3C=0x"+Binary.intToHex(var_3C));
					
					eax=ecx*11+8;
					eax+=(((long)eax)>>32)&0xF;
					var_40=eax>>4;
					//System.out.println("var_40=0x"+Binary.intToHex(var_40));
				}
				
				var_38=RandWithClamp(var_38);				
				var_3C=RandWithClamp(var_3C);
				var_40=RandWithClamp(var_40);
				
				var_38=(int)(((double)var_38)*0.0375+0.5); // *0.0375, round to nearest
				var_3C=(int)(((double)var_3C)*0.0375+0.5);
				var_40=(int)(((double)var_40)*0.0375+0.5);
				
				edx=((rand.rand()%0x28)+0x50)*var_18;
				edx=(int)((edx*0x51EB851Fl)>>32)>>5;
				edx+=(edx>>31)&1;
				sideLen=edx;
				buffer=RenderSphere(edx,0,var_38,0,var_3C,0,var_40);
			} // if edx==0
			
			edx = (int)(((long)AnArray[AnArrayCounter&0x3fff])%esi);
			AnArrayCounter++;
			edi=edx+ebp;
			ebp=AnArray[AnArrayCounter&0x3fff];
			AnArrayCounter++;
			
			esi=((CosLookup(ebp)*edi)>>15)+var_20;
			int eax=((SinLookup(ebp)*edi)>>15)+var_1C;
			esi-=sideLen;
			eax-=sideLen;
			
			blit(screen1,esi+1,eax+1,sideLen*2-1,sideLen*2-1,buffer,3);
			//blit(screen1,esi+1,eax+1,sideLen,sideLen,buffer,3);
			
		}
		
		Galaxy2(Flag1,var_8,var_C,var_10,var_14,var_18,var_1C,var_20);
		
		Galaxy3(Flag1,var_8,var_C,var_10,var_14,var_18,var_1C,var_20);
		
		// some fuzz around the galactic core
		{
			int esi = (int)(var_10*.1+.5);
			ebx = (int)(var_C*.1+.5);
			int edi=var_18-1;
			buffer=RenderSphere(var_18,0,esi,0,ebx,0,(int)(var_8*.1+.5));
			
			for (var_30=0x12;var_30!=0;var_30--) {
				
				edx=(int)((((rand.rand()%0xC8)-0x64)*var_18*0x51EB851Fl)>>(32+5));
				edx+=(edx>>31)&1;
				esi=edx;
				
				edx=(int)((((rand.rand()%0xC8)-0x64)*var_18*0x51EB851Fl)>>(32+5));
				edx+=(edx>>31)&1;
				blit(screen1,esi-edi+var_20,edx-edi+var_1C,edi*2+1,edi*2+1,buffer,3);
				//blit(screen1,esi-edi+var_20,edx-edi+var_1C,edi,edi,buffer,3);
			}
		}
		
		if (!SkyFlag) {
			var_24=var_14-var_18;
			ebp=var_18;
			
			for (var_30=rand.rand()%6+3;var_30>0;var_30--) {
				int edi = (rand.rand()%var_24) + ebp*2;
				if (edi>0) {
					ebx=rand.rand();
					starz(
							((CosLookup(ebx)*edi)>>0xf)+var_20,
							((SinLookup(ebx)*edi)>>0xf)+var_1C,
							0,ebp,0x109);
					
				}
			}
		}
		
		// galactic center star
		starz(var_20,var_1C,0,var_18,0x10B);
		
		BrightenGalaxy(var_20,var_1C,
				var_18*5+(((var_18*5)>>32)&3),
				var_10/3.0,var_C/3.0,var_8/3.0);
		//BrightenGalaxy(var_20,var_1C,
		//		var_18*5,
		//		var_10/3.0,var_C/3.0,var_8/3.0);
	}
	
	// A pointer to var_20 in Galaxy is passed, this must be a structure. Since none are
	// changed we pass them individually here.
	// Draws galactic arms.
	// blobs seem too large
	void Galaxy2(boolean arg_4, double arg_8, double arg_C, double arg_10, int arg_14, int arg_18,
			int arg_1C, int arg_20) {
		int var_4,var_8,var_C,var_10,var_14,var_18,var_1C,var_20,var_24,var_28,var_34;
		byte [] var_2C,var_30;
		System.out.println("Galaxy2(0x"+arg_4+
				","+arg_8+
				","+arg_C+
				","+arg_10+
				",0x"+Binary.intToHex(arg_14)+
				",0x"+Binary.intToHex(arg_18)+
				",0x"+Binary.intToHex(arg_1C)+
				",0x"+Binary.intToHex(arg_20)+")");
		if (!arg_4) return;
		
		var_20=(int)(arg_10*0.04+0.5);
		var_1C=(int)(arg_C*0.04+0.5);
		var_18=(int)(arg_8*0.04+0.5);
		
		for (var_24=0,var_28=rand.rand();var_24<0x640;var_24+=0xf,var_28+=0xf) {
			int edi,ebx,ebp;
			int edx=(int)((var_24*(arg_14-arg_18)*0x51EB851Fl)>>(32+9));
			edx+=(edx>>31)&1;
			
			// draw a circle
			edx+=arg_18;
			edi=edx;
			edx=((int)((edi*((long)0x88888889))>>32)+edi)>>3;
			
			ebx = edx + ((edx>>31)&1) + 1;
			
			edx=(int)(((rand.rand()%0x3c+0x46)*var_20*0x51EB851Fl)>>32)>>5;
			edx+=(edx>>31)&1;
			
			ebp=edx;
			
			edx=(int)(((rand.rand()%0x3c+0x46)*var_1C*0x51EB851Fl)>>32)>>5;
			edx+=(edx>>31)&1;
			
			var_34=edx;
			
			edx=(int)(((rand.rand()%0x3c+0x46)*var_18*0x51EB851Fl)>>32)>>5;
			edx+=(edx>>31)&1;
			
			if (ebp>0xff) ebp=0xff;
			if (var_34>0xff) var_34=0xff;
			if (edx>0xff) edx=0xff;
			
			var_30=RenderSphere(ebx*3,0,ebp,0,var_34,0,edx);
			
			// draw a circle

			edx+=arg_18;
			edx=((int)((edi*((long)0x88888889))>>32)+edi)>>3;
			
			ebx = edx + ((edx>>31)&1) + 1;
			
			edx=(int)(((rand.rand()%0x3c+0x46)*var_20*0x51EB851Fl)>>32)>>5;
			edx+=(edx>>31)&1;
			
			ebp=edx;
			
			edx=(int)(((rand.rand()%0x3c+0x46)*var_1C*0x51EB851Fl)>>32)>>5;
			edx+=(edx>>31)&1;
			
			var_34=edx;
			
			edx=(int)(((rand.rand()%0x3c+0x46)*var_18*0x51EB851Fl)>>32)>>5;
			edx+=(edx>>31)&1;
			
			if (ebp>0xff) ebp=0xff;
			if (var_34>0xff) var_34=0xff;
			if (edx>0xff) edx=0xff;
			
			var_2C=RenderSphere(ebx,0,ebp,0,var_34,0,edx);
			
			var_C=ebx*3-1;
			var_4=ebx-1;
			
			for (var_34=0;var_34<0x1800;var_34+=0x800) {
				edx=(int)((0x55555556l*var_34)>>32);
				edx+=(edx>>31)&1;
				
				ebp=var_28+edx;
				
				ebx=((CosLookup(ebp)*edi)>>15)+arg_20;
				ebp=((SinLookup(ebp)*edi)>>15)+arg_1C;
				
				//System.out.println("ebx=0x"+Binary.intToHex(ebx));
				
				if (var_30 != null) {
					edx=(int)((edi*0x55555556l)>>32);
					edx+=(edx>>31)&1;
					var_14=edx;
										
					edx=(int)((edi*0x2AAAAAABl)>>32);
					edx+=(edx>>31)&1;
					var_10=edx;
					
					for(var_8=3;var_8!=0;var_8--) {
						int esi=var_10-(rand.rand()%var_14)+ebx-var_C;
						
						blit(screen1,esi,var_10-(rand.rand()%var_14)+ebp-var_C,var_C*2+1,var_C*2+1,var_30,3);
						//rand.rand();
					}
					
					//System.out.println("***");
					
					for(var_8=9;var_8!=0;var_8--) {
						int esi=ebx-(rand.rand()%(edi*2))+edi-var_4;
						
						blit(screen1,esi,ebp-(rand.rand()%(edi*2))+edi-var_4,var_4*2+1,var_4*2+1,var_2C,3);
						//rand.rand();
					}
				}				
			}
		}
		
		/*
		 * - Wheel keeps spinnin'.
		 * - That only matters to those on the rim.
		 */
	}
	
	// plot galactic stars
	void Galaxy3(boolean arg_4, double arg_8, double arg_C, double arg_10, int arg_14, int arg_18,
			int arg_1C, int arg_20) {
		int var_4,var_8,var_C,var_10,var_14,var_18,var_1C,var_20,var_24,var_2C,var_28,var_30;
		System.out.println("Galaxy3(0x"+arg_4+
				","+arg_8+
				","+arg_C+
				","+arg_10+
				",0x"+Binary.intToHex(arg_14)+
				",0x"+Binary.intToHex(arg_18)+
				",0x"+Binary.intToHex(arg_1C)+
				",0x"+Binary.intToHex(arg_20)+")");
		
		
		var_1C=(int)(arg_10+0.5);
		var_18=(int)(arg_C+0.5);
		var_14=(int)(arg_8+0.5);
		
		int edx=(int)((arg_14*arg_14*0x66666667l)>>(32+5));
		edx+=(edx>>31)&1;
		
		if (edx==0) return;
		
		//var_20=edx;
		//{
		
		
		for (var_20=edx;var_20>0;var_20--) {
			int ecx=arg_14*5;
			ecx=arg_14+ecx*2;
			edx=(int)((ecx*0x66666667l)>>(32+2));
			edx+=(edx>>31)&1;
			int edi=edx;
			
			edi=rand.rand()%edi;
			
			int ebx=rand.rand();
			
			int ebp=((CosLookup(ebx)*edi)>>0xf)+arg_20;
			var_30=((SinLookup(ebx)*edi)>>0xf)+arg_1C;
			
			//System.out.println("ebp=0x"+Binary.intToHex(ebp)+" eax=0x"+Binary.intToHex(var_30));
			
			int esi;
			int eax;
			do {
				esi=rand.rand()&0xff;
				edi=rand.rand()&0xff;
				ebx=rand.rand()&0xff;
				
				edx=edi*edi;
				ecx=ebx*ebx;
				eax=esi*esi;
				
			} while (edx+ecx+eax>=0xc350);
			
			//System.out.println("esi=0x"+Binary.intToHex(esi)+
			//		" edi=0x"+Binary.intToHex(edi)+
			//		" ebx=0x"+Binary.intToHex(ebx));
			
			if (SkyFlag) {
				esi>>=1;
				edi>>=1;
				ebx>>=1;
			}
			
			esi=(int)(((rand.rand()%0x3C+0x46)*esi*0x51EB851Fl)>>(32+5));
			esi+=(esi>>31)&1;
			edi=(int)(((rand.rand()%0x3C+0x46)*edi*0x51EB851Fl)>>(32+5));
			edi+=(edi>>31)&1;
			ebx=(int)(((rand.rand()%0x3C+0x46)*ebx*0x51EB851Fl)>>(32+5));
			ebx+=(edx>>31)&1;
			
			if(esi>0xff)esi=0xff;
			if(edi>0xff)edi=0xff;
			if(ebx>0xff)ebx=0xff;
			
			eax=esi+var_1C;
			eax-=((long)eax)>>32;

			ecx=eax;
			eax=edi+var_18;
			eax-=((long)eax)>>32;

			edi=eax;
			eax=ebx+var_14;
			eax-=((long)eax)>>32;

			ecx>>=1;
			ebx=eax;
			eax=ecx;
			eax-=((long)eax)>>32;
			var_24=ecx;
			
			edi>>=1;
			esi=eax;
			eax=edi;
			eax-=((long)eax)>>32;
			var_28=edi;

			ebx>>=1;
			edi=eax;
			eax=ebx;
			eax-=((long)eax)>>32;
			var_2C=ebx;

			ebx=eax;
			esi>>=1;
			edi>>=1;
			ebx>>=1;

			//System.out.println("esi=0x"+Binary.intToHex(esi)+
			//		" edi=0x"+Binary.intToHex(edi)+
			//		" ebx=0x"+Binary.intToHex(ebx));

			edx=rand.rand()%0x64;
			if (edx<0x28) {
				OMGPONIES(screen1,ebp,var_30,var_24,var_28,var_2C);
				//OMGPONIES(screen1,ebp,var_30,0xff,0xff,0xff);
			} else if (edx<0x50) {
				OMGPONIES(screen1,ebp,var_30-1,esi,edi,ebx);
				OMGPONIES(screen1,ebp-1,var_30,esi,edi,ebx);
				OMGPONIES(screen1,ebp,var_30,var_24,var_28,var_2C);
				OMGPONIES(screen1,ebp+1,var_30,esi,edi,ebx);
				OMGPONIES(screen1,ebp,var_30+1,esi,edi,ebx);
			} else {
				
				OMGPONIES(screen1,ebp,var_30-1,esi,edi,ebx);
				var_2C=ebp+1;
				
				OMGPONIES(screen1,ebp+1,var_30-1,esi,edi,ebx);
				var_4=esi>>1;
				var_28=edi>>1;
				var_8=ebx>>1;
				OMGPONIES(screen1,ebp-1,var_30,var_4,var_28,var_8);
				var_10=ebx*3/2;
				var_24=edi*3/2;
				var_C=esi*3/2;
				OMGPONIES(screen1,ebp,var_30,var_C,var_24,var_10);
				OMGPONIES(screen1,var_2C,var_30,var_C,var_24,var_10);
				OMGPONIES(screen1,ebp+2,var_30,var_4,var_28,var_8);
				var_4=var_30+1;
				OMGPONIES(screen1,ebp,var_30+1,esi,edi,ebx);
				OMGPONIES(screen1,var_2C,var_4,esi,edi,ebx);
			}
		}
	}

	void OMGPONIES(Screen screen, int x, int y, int r, int g, int b) {
		if (x<0 || y<0 || x>=screen.width || y>=screen.height) return;
		
		//System.out.println("PONIEZ");
		
		int c = screen.getPixel(x,y);
		
		int c0=(c&0xff)+r;
		int c1=((c&0xff00)>>8)+g;
		int c2=((c&0xff0000)>>16)+b;
		
		if (c0>0xff) c0=0xff;
		if (c1>0xff) c1=0xff;
		if (c2>0xff) c2=0xff;
		screen.setPixel(x,y,(c0&0xff)|((c1<<8)&0xff00)|((c2<<16)&0xff0000));
	}

	
	int CosLookup(int x) {
		return SinTab[(x+0x200)&0x7ff];
	}
	int SinLookup(int x) {
		return SinTab[x&0x7ff];
	}
	
	int RandWithClamp(int c) {
		int edx=((rand.rand()%0x3c)+0x46);
		edx=(int)((edx*c*0x51EB851Fl)>>32)>>5;
		edx+=(edx>>31)&1;
		//System.out.println("RandWithClamp=0x"+Binary.intToHex(edx));
		if (edx<0xff) return edx;
		return 0xff;
	}
	
	byte [] RenderSphere(int a, int x0, int x1, int y0, int y1, int z0, int z1) {
		// a somewhat sloppy conversion
		//System.out.println("RenderCircle(0x"+Binary.intToHex(a)+","+x0+","+x1+","+y0+","+y1+","+z0+","+z1+")");
		//if (beenhere) return null;
		//beenhere=true;
		
		int var_4,var_8,var_10,var_14,var_18,var_1C,var_24;
		int [] var_C;
		
		if (a < 1) return null;
		
		int sideLen=a*2-1; // var_20, ebx
				
		int eax=(int)((long)sideLen*sideLen);
		int edi=eax*3;
		byte [] byteArray = new byte [edi];
		
		//System.out.println("byteArray size=0x"+Binary.intToHex(byteArray.length));
		
		for (int i=0;i<byteArray.length;i++) byteArray[i]=0; //redundant?
		
		if (a == 1) {
			byteArray[0]=(byte)z1;
			byteArray[1]=(byte)y1;
			byteArray[2]=(byte)x1;
			return byteArray;
		}
		
		var_C=new int [((sideLen*4+3)&0xFFFFFFFC)/4];
		//System.out.println("var_C size=0x"+Binary.intToHex(var_C.length));
		
		int ecx=a-1;
		edi=ecx;
		var_8=ecx;
		edi*=ecx;
		ecx=-ecx;
		
		ecx+=ecx;
		eax=edi;
		
		int i=0;
		for (var_4=sideLen;var_4>0;var_4--,i++) {
			var_C[i]=edi-eax;
			eax+=ecx+1;
			ecx+=2;
			
			//System.out.println("0x"+Binary.intToHex(var_C[i]));
		}
		

		var_14=z1-z0;
		var_18=y1-y0;
		var_1C=x1-x0;
		
		
		for (int y=0;y<sideLen;y++) {
			int edx = var_8;
			eax = y-edx;
			eax*=eax;
			
			var_24=(y-var_8)*(y-var_8);
			
			var_10 = var_24-var_8;
			for (int x=0;x<sideLen;x++) {
				
				//if (var_10>=var_C[x]) {
				if (var_C[x]>=var_10) {
					byteArray[(y*sideLen+x)*3]=1;
					byteArray[(y*sideLen+x)*3+1]=1;
					byteArray[(y*sideLen+x)*3+2]=1;
					
					//ecx = (var_24-var_C[x])<<1;
					ecx = (var_C[x]-var_24)<<1;
					if (ecx<0) ecx=0;
					
					eax=ecx;
					int ebx=edi*2;
					eax*=var_14;
					eax+=edi;
					//System.out.print("x="+x+" y="+y+" eax=0x"+Binary.intToHex(((eax/ebx+z0)&0xff)));
					byteArray[(y*sideLen+x)*3]=(byte)((eax/ebx+z0)&0xff);
					
					eax=ecx;
					eax*=var_18;
					eax+=edi;
					//System.out.print(" 0x"+Binary.intToHex(((eax/ebx+y0)&0xff)));
					byteArray[(y*sideLen+x)*3+1]=(byte)((eax/ebx+y0)&0xff);
					
					eax=ecx;
					eax*=var_1C;
					eax+=edi;
					//System.out.println(" 0x"+Binary.intToHex(((eax/ebx+x0)&0xff)));
					byteArray[(y*sideLen+x)*3+2]=(byte)((eax/ebx+x0)&0xff);
					
					//System.out.println("*********");
					
					//if (((eax/ebx+z0)&0xff)!=0) return byteArray;
				}
				/*screen1.setPixel(x,y,
						
						(((int)byteArray[(y*sideLen+x)*3])&0xff) |
						((((int)byteArray[(y*sideLen+x)*3+1])&0xff)<<8) |
						((((int)byteArray[(y*sideLen+x)*3+2])&0xff)<<16));*/
			}
		}
		
		return byteArray;
	}
	
	
	//static boolean beenhere=false;
	// simple addition, somewhat sloppily converted
	void blit(Screen screen, int x, int y, int width, int height, byte [] image, int a) {
		//if (beenhere) return;
		//beenhere=true;
		//System.out.println("blit(0x"+Binary.intToHex(x)+
		//		",0x"+Binary.intToHex(y)+
		//		",0x"+Binary.intToHex(width)+
		//		",0x"+Binary.intToHex(height)+")");
		if (width<1 || height<1 || x+width-1<0 || x >=screen.width) {
			return; //throw new IllegalArgumentException("bad things!");
		}
		if (image.length != width*height*3) throw new IllegalArgumentException("bad image size?");
		//System.out.println("image size="+image.length+", width*height*3="+(width/2)*(height/2)*3);
		
		int imagewidth=width; // actual width
		int imageoffset=0; // x offset into image
		
		if (x+width-1>=screen.width) {
			width+=(screen.width-(x+width-1))-1;
		}
		
		if (x<0) {
			width+=x;
			imageoffset-=(x*3);
			x=0;
		}
		
		for (int sy=y;sy<y+height;sy++) {
			if (sy<0) {imageoffset+=imagewidth*3; continue;}
			if (sy>=screen.height) break;
			
			for (int sx=x;sx<x+width;sx++) {
				int c = screen.getPixel(sx,sy);
				
				//System.out.println("0x"+Binary.intToHex(c));				
				int c0=(c&0xff)+(((int)image[imageoffset++])&0xff);
				int c1=((c&0xff00)>>8)+(((int)image[imageoffset++])&0xff);
				int c2=((c&0xff0000)>>16)+(((int)image[imageoffset++])&0xff);
				
				if (c0>0xff) c0=0xff;
				if (c1>0xff) c1=0xff;
				if (c2>0xff) c2=0xff;
				screen.setPixel(sx,sy,(c0&0xff)|((c1<<8)&0xff00)|((c2<<16)&0xff0000));
			}
			imageoffset-=width*3;
			imageoffset+=imagewidth*3;
		}
	}
	
	void starz(int x,int y, int start, int end, int a) {
		int ecx=1;
		int var_4,var_8;
		//System.out.println("starz 0x"+Binary.intToHex(x)+" 0x"+Binary.intToHex(y));
		if (end>0x10) {
			
			ecx=(AnArray[AnArrayCounter&0x3fff]&3)+1;
			AnArrayCounter++;
		}		
		
		for(var_4=var_8=(end/ecx);var_8<=end;var_8+=var_4) {
			for (int ebx=start;ebx<=var_8;ebx++) {
				for (int ebp=0;ebp<0x800;ebp+=0x14) {
					int edi=(rand.rand()%0x14)+ebp;
					int esi=CosLookup(edi)*ebx;
					esi+=(((long)esi)>>32)&0x7fff;
					esi=(esi>>0xf)+x;
					AnArrayCounter+=2;
					int eax=SinLookup(edi)*ebx;
					eax+=(((long)eax)>>32)&0x7fff;
					eax=(eax>>0xf)+y;
					AnArrayCounter+=2; // used to use this, still keeping for compatibility?
					if (esi<MinX || esi>MaxX || eax>=HorizonLine || eax<0) continue;
					stizzle(screen1,esi,eax,a);
				}
			}
			
		}
	}
	
	void stizzle(Screen screen, int x, int y, int a) {
		int c=screen.getPixel(x,y);
		
		int c0=((c&0xff)*a+128)>>8;
		int c1=(((c&0xff00)>>8)*a+128)>>8;
		int c2=(((c&0xff0000)>>16)*a+128)>>8;
		
		if (c0>0xff) c0=0xff;
		if (c1>0xff) c1=0xff;
		if (c2>0xff) c2=0xff;
		screen.setPixel(x,y,(c0&0xff)|((c1<<8)&0xff00)|((c2<<16)&0xff0000));

	}
	
	void BrightenGalaxy(int x, int y, int a, double f0, double f1, double f2) {
		byte [] buf = RenderSphere(a,0,(int)(f0+0.5),0,(int)(f1+0.5),0,(int)(f2+0.5));
		blit(screen1,x-a+1,y-a+1,a*2-1,a*2-1,buf,3);
	}
	
	void Planet1() {
		
	}
	
	void Planet2() {
		
	}
}
