package distantplanets;


/**
 * An image, 24 bpp
 * @author Adam Gashlin
 *
 */
public class Screen {
	int width, height;
	
	int [] data;

	public Screen(int width, int height) {
		this.width=width;
		this.height=height;
		
		data = new int [width*height];
	}
	
	public int getPixel(int x, int y) {return data[x+y*width]&0x00ffffff;}
	public void setPixel(int x, int y, int p) {data[x+y*width]=p;}
	public int getPixel(int n) {return data[n]&0x00ffffff;}
	public void setPixel(int n, int p) {data[n]=p;}
	public int [] getData() {return data;}
	
	public int getWidth() {return width;}
	public int getHeight() {return height;}
	//public int getLineSize() {return ((width*3)+3)&0xfffffffc;}
	
	public void clear() {
		for (int i=0; i<data.length; i++) data[i]=0;
	}

}
